Imports System.IO

Public Class Form1
    ' If we launched from the Send To menu,
    ' use the argument as our directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If My.Application.CommandLineArgs.Count > 0 Then
            txtDirectory.Text = My.Application.CommandLineArgs(0)
            txtTarget.Focus()
        End If
    End Sub

    ' Search.
    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        lstResults.Items.Clear()
        Dim dir_info As New DirectoryInfo(txtDirectory.Text)

        ListFiles(lstResults, cboPattern.Text, dir_info, txtTarget.Text)

        Beep()
    End Sub

    ' Add the files in this directory's subtree 
    ' that match the pattern to the ListBox.
    Private Sub ListFiles(ByVal lst As ListBox, ByVal pattern As String, ByVal dir_info As DirectoryInfo, ByVal target As String)
        ' Get the files in this directory.
        Dim fs_infos() As FileInfo = dir_info.GetFiles(pattern)
        For Each fs_info As FileInfo In fs_infos
            If target.Length = 0 Then
                lstResults.Items.Add(fs_info.FullName)
            Else
                Dim txt As String = File.ReadAllText(fs_info.FullName)
                If txt.IndexOf(target, StringComparison.OrdinalIgnoreCase) >= 0 Then
                    lstResults.Items.Add(fs_info.FullName)
                End If
            End If
        Next fs_info
        fs_infos = Nothing

        ' Search subdirectories.
        Dim subdirs() As DirectoryInfo = dir_info.GetDirectories()
        For Each subdir As DirectoryInfo In subdirs
            ListFiles(lst, pattern, subdir, target)
        Next subdir
    End Sub
End Class
